package com.tigrek.iuea.Aug2018;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.JPanel;

public class Canvas extends JPanel {
	ToolPanel tp;
	int tool=ToolPanel.OVAL;
	boolean start=false;
	Point stPoint=null;
	Point endPoint=null;
	ArrayList<Shape> shapes=new ArrayList<Shape>();
	public Canvas() {
		setLayout(null);
		this.setFocusable(true);
	}
	public void mouseP(MouseEvent e)
	{
		if(!start)
		{
			stPoint=e.getPoint();
			start=true;
			stPoint=e.getPoint();
		}
	}
	public void mouseR(MouseEvent e)
	{
		if(start)
		{
			endPoint=e.getPoint();
			Shape r=new Shape(tool,stPoint.x,stPoint.y,endPoint.x-stPoint.x,endPoint.y-stPoint.y);
			shapes.add(r);
			start=false;
		}
	}
	public void mouseD(MouseEvent e)
	{
		int x=e.getX();
		int y=e.getY();
		if(start)
		{
			endPoint=new Point(x,y);
		}
		repaint();
	}
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		if(tool==ToolPanel.ERASER)
		{
			/// erase everything
			System.out.println("Erase all");
			g.setColor(Color.WHITE);
			Rectangle rv=this.getBounds();
			g.fillRect(rv.x,rv.y,rv.width,rv.height);
			shapes=new ArrayList<Shape>();
		}else
		{
			Iterator itr =shapes.iterator();
			while(itr.hasNext()) {
				Shape sh = (Shape) itr.next();
				sh.draw(g);
			}
			drawLast(g);
		}
	}
	public void drawLast(Graphics g)
	{
		if(start)
		{
			if(tool==ToolPanel.OVAL)
			{
				if(stPoint!=null && endPoint!=null)
					g.drawOval((int)stPoint.getX(), (int)stPoint.getY(), (int)endPoint.getX()-(int)stPoint.getX(), (int)endPoint.getY()-(int)stPoint.getY());
			}else if(tool==ToolPanel.RECT)
			{
				if(stPoint!=null && endPoint!=null)
					g.drawRect((int)stPoint.getX(), (int)stPoint.getY(), (int)endPoint.getX()-(int)stPoint.getX(), (int)endPoint.getY()-(int)stPoint.getY());
			}
		}
	}
	public void setTool(int t)
	{
		tool=t;
	}
	public int getTool()
	{
		return tool;
	}
}
